Codeforces Round #502 D(状压)

D. The Wu

time limit per test

2 seconds

memory limit per test

256 megabytes

Childan is making up a legendary story and trying to sell his forgery — a necklace with a strong sense of "Wu" to the Kasouras. But Mr. Kasoura is challenging the truth of Childan's story. So he is going to ask a few questions about Childan's so-called "personal treasure" necklace.

This "personal treasure" is a multiset S of m "01-strings".

A "01-string" is a string that contains n characters "0" and "1". For example, if n=4, strings "0110", "0000", and "1110" are "01-strings", but "00110" (there are 5 characters, not 4) and "zero" (unallowed characters) are not.

Note that the multiset S can contain equal elements.

Frequently, Mr. Kasoura will provide a "01-string" t and ask Childan how many strings s are in the multiset S such that the "Wu" value of the pair (s,t) is not greater than k.

Mrs. Kasoura and Mr. Kasoura think that if si=ti (1≤i≤n) then the "Wu" value of the character pair equals to wi, otherwise 0. The "Wu" value of the "01-string" pair is the sum of the "Wu" values of every character pair. Note that the length of every "01-string" is equal to n.

For example, if w=[4,5,3,6], "Wu" of ("1001", "1100") is 7 because these strings have equal characters only on the first and third positions, so w1+w3=4+3=7.

You need to help Childan to answer Mr. Kasoura's queries. That is to find the number of strings in the multiset S

such that the "Wu" value of the pair is not greater than k.

Input

The first line contains three integers n, m, and q (1≤n≤12, 1≤q,m≤5⋅105) — the length of the "01-strings", the size of the multiset S, and the number of queries.

The second line contains n integers w1,w2,…,wn (0≤wi≤100) — the value of the i-th caracter.

Each of the next m lines contains the "01-string" s of length n — the string in the multiset S.

Each of the next q lines contains the "01-string" t of length n and integer k (0≤k≤100

) — the query.

Output

For each query, print the answer for this query.

Examples

Input

2 4 5
40 20
01
01
10
11
00 20
00 40
11 20
11 40
11 60

Output

Copy

2
4
2
3
4

Input

1 2 4
100
0
1
0 0
0 100
1 0
1 100

Output

1
2
1
2

Note

In the first example, we can get:

"Wu" of ("01", "00") is 40.

"Wu" of ("10", "00") is 20.

"Wu" of ("11", "00") is 0.

"Wu" of ("01", "11") is 20.

"Wu" of ("10", "11") is 40.

"Wu" of ("11", "11") is 60.

In the first query, pairs ("11", "00") and ("10", "00") satisfy the condition since their "Wu" is not greater than 20.

In the second query, all strings satisfy the condition.

In the third query, pairs ("01", "11") and ("01", "11") satisfy the condition. Note that since there are two "01" strings in the multiset, the answer is 2, not 1.

In the fourth query, since k

was increased, pair ("10", "11") satisfies the condition too.

In the fifth query, since k

was increased, pair ("11", "11") satisfies the condition too.

题目大意:给定 m 个长度为 n 的 “01” 串的集合 S ,每个位上有一个权重,进行 q 个查询,每次计算集合 S 中有多少个串满足与给定串的 “Wu” 值小于等于给定值。 “Wu” 值的计算方式为:两个串对应位置的值相等时该位的权重加入总的 “Wu” 值中。

数据范围为 1e5 ,故只能考虑 O (n) 或 O(nlogn) 的解法。

观察到查询中每个串与 S 中串的 “Wu” 值范围为 [0,100],而串的长度为 0 ~ 12 ,所以这里可以考虑对每个串 i 枚举所有情况。在输入时统计每个串的出现频率,将串作为二进制数映射为整数,两个串的 “Wu” 值记为 j ,cal[i][j] 表示 S 中可以与串 i 得到 “Wu” 值为 j 的串的个数,对于大于100的 j 直接舍弃即可,可以节约内存。以 O(2^n * 2^n * n) 的复杂度进行预处理,在查询时便可在常数时间进行单次的统计: q = \sum_{i = 1}^{sum}cal[t][i]

详见代码:

#include
#include
#include
using namespace std;
const int maxn = 1 << 12 + 5;
int num[maxn];
int cal[maxn][105];
int c[20];
int main()
{
    memset(num,0,sizeof(num));
    int n,m,q;
    char in[20];
    scanf("%d %d %d",&n,&m,&q);
    for(int i = 0;i < n; ++i) scanf("%d",&c[i]);
    for(int i = 0;i < m; ++i)
    {
        int temp = 0;
        scanf(" %s",in);
        for(int j = 0;in[j] != '\0'; ++j)
        {
            if(in[j] - '0') temp += (1 << (n - 1 - j));
        }
        num[temp]++;
    }
    for(int i = 0;i < (1 << n); ++i)
    {
        for(int j = 0;j < (1 << n); ++j)
        {
            int temp = 0;
            for(int k = 0;k < n; ++k)
            {
                if((i & (1 << k)) == (j & (1 << k)))
                {
                    temp += c[n - k - 1];
                }
            }
            if(temp <= 100) cal[i][temp] += num[j];
        }
    }
    int sum,ans;
    for(int i = 0;i < q; ++i)
    {
        ans = 0;
        scanf(" %s %d",in,&sum);
        int temp = 0;
        for(int j = 0;in[j] != '\0'; ++j)
        {
            if(in[j] - '0') temp += (1 << (n - 1 - j));
        }
        for(int j = 0;j <= sum; ++j) ans += cal[temp][j];
        printf("%d\n",ans);
    }
    return 0;
}

 

你可能感兴趣的:(动态规划)